	.model tiny
	.386
	.code
ORG 100h
start:
; Open da file 

	push	0A000h
	pop	es

        mov     bx,80h
        add     bl,ds:[bx]
        mov     ds:[bx+1],bh
        mov     ax,3d00h
        mov     dx,82h
        int     21h
	xchg	bx,ax
	mov	al,13h
	int	10h
start_over:	
	cwd
	mov	ah,3Fh
	push	ax
	pop	ds
	mov	cx,128+4
	int	21h

	mov	bp,ds:[6]	;get the number of frames!
	mov	cx,ds:[128]
	mov	di,cx

	mov	ax,ds:[16]	;get the speed in video tics
	mov	fs,ax
; Read da chunks 
@1:
	mov	ax,ds
	cwd
	int	21h
	mov	cx,ds:[2]
	mov	si,12

@2:				;11
	lodsd
	sub	ax,6
	xchg	dx,ax
	lodsw

	pushad	
	sub	al,11
	jnz	@3

	lodsw
	xchg	cx,ax
packet_loop:
	lodsw
	mov	dx,3c8h
	out	dx,al
	inc	dx
pal_write_loop:
	outsb
	outsb
	outsb
	dec	ah
	jnz	pal_write_loop
	loop	packet_loop	
@3:				;12
	dec	ax
	jnz	@4
	xchg	ax,cx

	lodsw	
	imul	di,ax,320
	lodsw	
	xchg	bp,ax
line_loop:
	push	di
	lodsb
	xchg	bx,ax
	or	bl,bl
	jz	skip_line1			
sub_loop:
	lodsw
	mov	cl,al
	add	di,cx
	mov	cl,ah
	or	cl,cl
	js	un_compress
	rep	movsb
	jmp	skip_line
un_compress:
	neg	cl
	lodsb
	rep	stosb
skip_line:
	dec	bl
	jnz	sub_loop
skip_line1:
	pop	di
	add	di,320
	dec	bp
	jnz	line_loop
@4:				;13
	dec	ax
	jnz	@5

	xor	di,di
	mov	cx,320*200
	rep	stosb

@5:				;15
	sub	al,2
	jnz	@6
	
	xor	di,di
	mov	bl,200

Brun_chunk:
	lodsb
	xchg	ax,cx

line_brun_loop:
	push	cx
	lodsb
	xchg	cx,ax
	or	cl,cl
	js	compressed

	lodsb
	rep	stosb
	jmp	brun_loop
compressed:
	neg	cl
	rep	movsb	
Brun_loop:
	pop	cx
	loop	line_brun_loop	

	dec	bx
	jnz	Brun_chunk
	xchg	ax,bx
@6:				;16
	dec	ax
	jnz	end_loop
	xchg	ax,di
	mov	cx,320*200
	rep	movsb
end_loop:
	mov	ah,1
	int	16h
	popad
	jnz	exit

	add	si,dx
	dec	cx
	jnz	@2

	mov	cx,fs
	mov	dx,3dah
VRT:
	in	al,dx
	test	al,8
	jnz	VRT	
NVRT:
	in	al,dx
	test	al,8
	jz	NVRT	
	loop	vrt

	mov	di,ds:[di-4]
	mov	cx,di
	dec	bp
	jnz	@1

	cwd
	xchg	bp,cx
	mov	ax,4200h
	int	21h

	jmp	start_over
exit:
	mov	al,03h
	int	10h
	ret

	end start 